<?php

namespace Drupal\api_tokens;

use Drupal\Core\Plugin\DefaultPluginManager;
use Drupal\Core\Cache\CacheBackendInterface;
use Drupal\Core\Extension\ModuleHandlerInterface;

/**
 * Manages API token handlers.
 */
class ApiTokenManager extends DefaultPluginManager {

  /**
   * Constructs an ApiTokenManager object.
   *
   * @param \Traversable $namespaces
   *   An object that implements \Traversable which contains the root paths
   *   keyed by the corresponding namespace to look for plugin implementations.
   * @param \Drupal\Core\Cache\CacheBackendInterface $cache_backend
   *   Cache backend instance to use.
   * @param \Drupal\Core\Extension\ModuleHandlerInterface $module_handler
   *   The module handler to invoke the alter hook with.
   */
  public function __construct(\Traversable $namespaces, CacheBackendInterface $cache_backend, ModuleHandlerInterface $module_handler) {
    parent::__construct(
      'Plugin/ApiToken',
      $namespaces,
      $module_handler,
      'Drupal\api_tokens\Plugin\ApiTokenInterface',
      'Drupal\api_tokens\Annotation\ApiToken'
    );
    $this->alterInfo('api_tokens_info');
    $this->setCacheBackend($cache_backend, 'api_tokens_plugins');
  }

}
